Loading...
Searching...
No Matches
wayland::zwp_linux_dmabuf_feedback_v1_t Class Reference

dmabuf feedback More...

`#include <wayland-client-protocol-unstable.hpp>`

Inheritance diagram for wayland::zwp_linux_dmabuf_feedback_v1_t:
[legend]
Collaboration diagram for wayland::zwp_linux_dmabuf_feedback_v1_t:
[legend]

## Public Types

enum class | wrapper_type { standard , display , foreign , proxy_wrapper }

## Public Member Functions

std::function< void()> & | on_done ()
| all feedback has been sent
std::function< void(int, uint32_t)> & | on_format_table ()
| format and modifier table
std::function< void(array_t)> & | on_main_device ()
| preferred main device
std::function< void()> & | on_tranche_done ()
| a preference tranche has been sent
std::function< void(array_t)> & | on_tranche_target_device ()
| target device
std::function< void(array_t)> & | on_tranche_formats ()
| supported buffer format modifier
std::function< void(zwp_linux_dmabuf_feedback_v1_tranche_flags)> & | on_tranche_flags ()
| tranche flags
uint32_t | get_id () const
| Get the id of a proxy object.
std::string | get_class () const
| Get the interface name (class) of a proxy object.
uint32_t | get_version () const
| Get the protocol object version of a proxy object.
wrapper_type | get_wrapper_type () const
| Get the type of a proxy object.
void | set_queue (event_queue_t queue)
| Assign a proxy to an event queue.
wl_proxy * | c_ptr () const
| Get a pointer to the underlying C struct.
bool | proxy_has_object () const
| Check whether this wrapper actually wraps an object.
| operator bool () const
| Check whether this wrapper actually wraps an object.
bool | operator== (const proxy_t &right) const
| Check whether two wrappers refer to the same object.
bool | operator!= (const proxy_t &right) const
| Check whether two wrappers refer to different objects.
void | proxy_release ()
| Release the wrapped object (if any), making this an empty wrapper.

## Detailed Description

dmabuf feedback

This object advertises dmabuf parameters feedback. This includes the preferred devices and the supported formats/modifiers.

The parameters are sent once when this object is created and whenever they change. The done event is always sent once after all parameters have been sent. When a single parameter changes, all parameters are re-sent by the compositor.

Compositors can re-send the parameters when the current client buffer allocations are sub-optimal. Compositors should not re-send the parameters if re-allocating the buffers would not result in a more optimal configuration. In particular, compositors should avoid sending the exact same parameters multiple times in a row.

The tranche_target_device and tranche_modifier events are grouped by tranches of preference. For each tranche, a tranche_target_device, one tranche_flags and one or more tranche_modifier events are sent, followed by a tranche_done event finishing the list. The tranches are sent in descending order of preference. All formats and modifiers in the same tranche have the same preference.

To send parameters, the compositor sends one main_device event, tranches (each consisting of one tranche_target_device event, one tranche_flags event, tranche_modifier events and then a tranche_done event), then one done event.

Definition at line 1939 of file wayland-client-protocol-unstable.hpp.

## Member Enumeration Documentation

## wrapper_type

enum class wayland::proxy_t::wrapper_type

strong inherited

Underlying wl_proxy type and properties of a proxy_t that affect construction, destruction, and event handling

Enumerator
standard | C pointer is a standard type compatible with wl_proxy*. Events are dispatched and it is destructed when the proxy_t is destructed. User data is set.
display | C pointer is a wl_display*. No events are dispatched, wl_display_disconnect is called when the proxy_t is destructed. User data is set.

foreign

C pointer is a standard type compatible with wl_proxy*, but another library owns it and it should not be touched in a way that could affect the operation of the other library. No events are dispatched, wl_proxy_destroy is not called when the proxy_t is destructed, user data is not touched. Consequently, there is no reference counting for the proxy_t. Lifetime of such wrappers should preferably be short to minimize the chance that the owning library decides to destroy the wl_proxy.

proxy_wrapper | C pointer is a wl_proxy* that was constructed with wl_proxy_create_wrapper. No events are dispatched, wl_proxy_wrapper_destroy is called when the proxy_t is destroyed. Reference counting is active. A reference to the proxy_t creating this proxy wrapper is held to extend its lifetime until after the proxy wrapper is destroyed.

Definition at line 117 of file wayland-client.hpp.

## Member Function Documentation

## c_ptr()

wl_proxy * wayland::proxy_t::c_ptr | ( |  | ) | const

inherited

Get a pointer to the underlying C struct.

Returns
  The underlying wl_proxy wrapped by this proxy_t if it exists, otherwise an exception is thrown

## get_class()

std::string wayland::proxy_t::get_class | ( |  | ) | const

inherited

Get the interface name (class) of a proxy object.

Returns
  The interface name of the object associated with the proxy

## get_id()

uint32_t wayland::proxy_t::get_id | ( |  | ) | const

inherited

Get the id of a proxy object.

Returns
  The id the object associated with the proxy

## get_version()

uint32_t wayland::proxy_t::get_version | ( |  | ) | const

inherited

Get the protocol object version of a proxy object.

Gets the protocol object version of a proxy object, or 0 if the proxy was created with unversioned API.

A returned value of 0 means that no version information is available, so the caller must make safe assumptions about the object's real version.

display_t will always return version 0.

Returns
  The protocol object version of the proxy or 0

## get_wrapper_type()

wrapper_type wayland::proxy_t::get_wrapper_type | ( |  | ) | const

inline inherited

Get the type of a proxy object.

Definition at line 303 of file wayland-client.hpp.

## on_done()

std::function< void()> & zwp_linux_dmabuf_feedback_v1_t::on_done | ( |  | ) |

all feedback has been sent

This event is sent after all parameters of a wp_linux_dmabuf_feedback object have been sent.

This allows changes to the wp_linux_dmabuf_feedback parameters to be seen as atomic, even if they happen via multiple events.

Definition at line 5429 of file wayland-client-protocol-unstable.cpp.

## on_format_table()

std::function< void(int, uint32_t)> & zwp_linux_dmabuf_feedback_v1_t::on_format_table | ( |  | ) |

format and modifier table

Parameters

  fd | table file descriptor
  size | table size, in bytes

This event provides a file descriptor which can be memory-mapped to access the format and modifier table.

The table contains a tightly packed array of consecutive format + modifier pairs. Each pair is 16 bytes wide. It contains a format as a 32-bit unsigned integer, followed by 4 bytes of unused padding, and a modifier as a 64-bit unsigned integer. The native endianness is used.

The client must map the file descriptor in read-only private mode.

Compositors are not allowed to mutate the table file contents once this event has been sent. Instead, compositors must create a new, separate table file and re-send feedback parameters. Compositors are allowed to store duplicate format + modifier pairs in the table.

Definition at line 5434 of file wayland-client-protocol-unstable.cpp.

## on_main_device()

std::function< void(array_t)> & zwp_linux_dmabuf_feedback_v1_t::on_main_device | ( |  | ) |

preferred main device

Parameters

  device | device dev_t value

This event advertises the main device that the server prefers to use when direct scan-out to the target device isn't possible. The advertised main device may be different for each wp_linux_dmabuf_feedback object, and may change over time.

There is exactly one main device. The compositor must send at least one preference tranche with tranche_target_device equal to main_device.

Clients need to create buffers that the main device can import and read from, otherwise creating the dmabuf wl_buffer will fail (see the wp_linux_buffer_params.create and create_immed requests for details). The main device will also likely be kept active by the compositor, so clients can use it instead of waking up another device for power savings.

In general the device is a DRM node. The DRM node type (primary vs. render) is unspecified. Clients must not rely on the compositor sending a particular node type. Clients cannot check two devices for equality by comparing the dev_t value.

If explicit modifiers are not supported and the client performs buffer allocations on a different device than the main device, then the client must force the buffer to have a linear layout.

Definition at line 5439 of file wayland-client-protocol-unstable.cpp.

## on_tranche_done()

std::function< void()> & zwp_linux_dmabuf_feedback_v1_t::on_tranche_done | ( |  | ) |

a preference tranche has been sent

This event splits tranche_target_device and tranche_modifier events in preference tranches. It is sent after a set of tranche_target_device and tranche_modifier events; it represents the end of a tranche. The next tranche will have a lower preference.

Definition at line 5444 of file wayland-client-protocol-unstable.cpp.

## on_tranche_flags()

std::function< void(zwp_linux_dmabuf_feedback_v1_tranche_flags)> & zwp_linux_dmabuf_feedback_v1_t::on_tranche_flags | ( |  | ) |

tranche flags

Parameters

  flags | tranche flags

This event sets tranche-specific flags.

The scanout flag is a hint that direct scan-out may be attempted by the compositor on the target device if the client appropriately allocates a buffer. How to allocate a buffer that can be scanned out on the target device is implementation-defined.

This event is tied to a preference tranche, see the tranche_done event.

Definition at line 5459 of file wayland-client-protocol-unstable.cpp.

## on_tranche_formats()

std::function< void(array_t)> & zwp_linux_dmabuf_feedback_v1_t::on_tranche_formats | ( |  | ) |

supported buffer format modifier

Parameters

  indices | array of 16-bit indexes

This event advertises the format + modifier combinations that the compositor supports.

It carries an array of indices, each referring to a format + modifier pair in the last received format table (see the format_table event). Each index is a 16-bit unsigned integer in native endianness.

For legacy support, DRM_FORMAT_MOD_INVALID is an allowed modifier. It indicates that the server can support the format with an implicit modifier. When a buffer has DRM_FORMAT_MOD_INVALID as its modifier, it is as if no explicit modifier is specified. The effective modifier will be derived from the dmabuf.

A compositor that sends valid modifiers and DRM_FORMAT_MOD_INVALID for a given format supports both explicit modifiers and implicit modifiers.

Compositors must not send duplicate format + modifier pairs within the same tranche or across two different tranches with the same target device and flags.

This event is tied to a preference tranche, see the tranche_done event.

For the definition of the format and modifier codes, see the wp_linux_buffer_params.create request.

Definition at line 5454 of file wayland-client-protocol-unstable.cpp.

## on_tranche_target_device()

std::function< void(array_t)> & zwp_linux_dmabuf_feedback_v1_t::on_tranche_target_device | ( |  | ) |

target device

Parameters

  device | device dev_t value

This event advertises the target device that the server prefers to use for a buffer created given this tranche. The advertised target device may be different for each preference tranche, and may change over time.

There is exactly one target device per tranche.

The target device may be a scan-out device, for example if the compositor prefers to directly scan-out a buffer created given this tranche. The target device may be a rendering device, for example if the compositor prefers to texture from said buffer.

The client can use this hint to allocate the buffer in a way that makes it accessible from the target device, ideally directly. The buffer must still be accessible from the main device, either through direct import or through a potentially more expensive fallback path. If the buffer can't be directly imported from the main device then clients must be prepared for the compositor changing the tranche priority or making wl_buffer creation fail (see the wp_linux_buffer_params.create and create_immed requests for details).

If the device is a DRM node, the DRM node type (primary vs. render) is unspecified. Clients must not rely on the compositor sending a particular node type. Clients cannot check two devices for equality by comparing the dev_t value.

This event is tied to a preference tranche, see the tranche_done event.

Definition at line 5449 of file wayland-client-protocol-unstable.cpp.

## operator bool()

wayland::proxy_t::operator bool | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## operator!=()

bool wayland::proxy_t::operator!= | ( | const proxy_t & | right | ) | const

inherited

Check whether two wrappers refer to different objects.

## operator==()

bool wayland::proxy_t::operator== | ( | const proxy_t & | right | ) | const

inherited

Check whether two wrappers refer to the same object.

## proxy_has_object()

bool wayland::proxy_t::proxy_has_object | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## proxy_release()

void wayland::proxy_t::proxy_release | ( |  | ) |

inherited

Release the wrapped object (if any), making this an empty wrapper.

Note that display_t instances cannot be released this way. Attempts to do so are ignored.

Examples
  foreign_display.cpp.

## set_queue()

void wayland::proxy_t::set_queue | ( | event_queue_t | queue | ) |

inherited

Assign a proxy to an event queue.

Parameters

  queue | The event queue that will handle this proxy

Assign proxy to event queue. Events coming from proxy will be queued in queue instead of the display's main queue.

See also: display_t::dispatch_queue().

Examples
  proxy_wrapper.cpp.

The documentation for this class was generated from the following files:

- obj-x86_64-linux-gnu/wayland-client-protocol-unstable.hpp
- obj-x86_64-linux-gnu/wayland-client-protocol-unstable.cpp
- obj-x86_64-linux-gnu/wayland-server-protocol-unstable.cpp